package drop;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * tH`쐬NX
 */
public class DropShape{

/** <i>f</i> W1K̍ől */
  public static final double DFLIMIT=1.0E5;

/** A_X|oVtH[X|[g@̗\qWi[z */
  public static final double CP[][]=
    {{1.0},
     {1.5,-0.5},
     {23.0/12.0,-16.0/12.0,5.0/12.0},
     {55.0/24.0,-59.0/24.0,37.0/24.0,-9.0/24.0},
     {1901.0/720.0,-277.0/720.0,2616.0/720.0,-1274.0/720.0,
      251.0/720.0}};

/** A_X|oVtH[X|[g@̕␳qWi[z */
  public static final double CC[][]=
    {{0.5,0.5},
     {0.5,0.5},
     {5.0/12.0,8.0/12.0,-1.0/12.0},
     {9.0/24.0,19.0/24.0,-5.0/24.0,1.0/24.0},
     {251.0/720.0,646.0/720.0,-264.0/720.0,106.0/720.0,-19.0/720.0}};

//--------------------------------------------------------------------//
/**
 * A_X|oVtH[X|[g@ (W) ŉtH`쐬
 * @param n f[^_̍ől
 * @param r0 <i>r</i> W̏l
 * @param dr0 <i>r</i> W̑̏l
 * @param r <i>r</i> Wi[z
 * @param f <i>f</i> Wi[z
 * @param df <i>f</i> W1Ki[z
 * @param beta W
 * @return ۂ̃f[^_
 */
  public static int ABMMethod(int n,double r0,double dr0,double r[],
      	      	      	      double f[],double df[],double beta){
    double ff[]=new double[n];
    double dff[]=new double[n];
    r[0]=r0;
    f[0]=0.0;
    df[0]=0.0;
    ff[0]=df[0];
    dff[0]=laplaceD(r[0],f[0],df[0],beta);
    for(int i=1;i<n;i++){
      double dr=dr0/Math.sqrt(1.0+df[i-1]*df[i-1]);
      r[i]=r[i-1]+dr;
      int i2=Math.min(i-1,4);
      double fp=0.0;
      double dfp=0.0;
      for(int j=0;j<CP[i2].length;j++){
      	fp+=CP[i2][j]*ff[i-j-1];
      	dfp+=CP[i2][j]*dff[i-j-1];
      }
      fp=f[i-1]+dr*fp;
      dfp=df[i-1]+dr*dfp;
      ff[i]=dfp;
      dff[i]=laplaceD(r[i],fp,dfp,beta);
      fp=0.0;
      dfp=0.0;
      for(int j=0;j<CC[i2].length;j++){
      	fp+=CC[i2][j]*ff[i-j];
      	dfp+=CC[i2][j]*dff[i-j];
      }
      f[i]=f[i-1]+dr*fp;
      df[i]=df[i-1]+dr*dfp;
      if(Math.abs(df[i])>DFLIMIT){
      	return i+1;
      }
    }
    return n;
  }

//--------------------------------------------------------------------//
/**
 * A_X|oVtH[X|[g@ (ɍW) ŉtH`쐬
 * @param n f[^_̍ől
 * @param dt <i></i> W̑
 * @param t <i></i> Wi[z
 * @param r <i>r</i> Wi[z
 * @param dr <i>r</i> W1Ki[z
 * @param gamma pxi[z
 * @param gammaMax ڐGp̍ől
 * @param beta W
 * @return ۂ̃f[^_
 */
  public static int ABMMethod(int n,double dt,double t[],double r[],
      	      	      	      double dr[],double gamma[],
      	      	      	      double gammaMax,double beta){
    double drr1[]=new double[n];
    double drr2[]=new double[n];
    t[0]=0.0;
    r[0]=1.0;
    dr[0]=0.0;
    drr1[0]=dr[0];
    drr2[0]=laplaceP(t[0],r[0],dr[0],beta);
    for(int i=1;i<n;i++){
      t[i]=t[i-1]+dt;
      int i2=Math.min(i-1,4);
      double drp=0.0;
      double dr2p=0.0;
      for(int j=0;j<CP[i2].length;j++){
      	drp+=CP[i2][j]*drr1[i-j-1];
      	dr2p+=CP[i2][j]*drr2[i-j-1];
      }
      drp=r[i-1]+dt*drp;
      dr2p=dr[i-1]+dt*dr2p;
      drr1[i]=dr2p;
      drr2[i]=laplaceP(t[i],drp,dr2p,beta);
      drp=0.0;
      dr2p=0.0;
      for(int j=0;j<CC[i2].length;j++){
      	drp+=CC[i2][j]*drr1[i-j];
      	dr2p+=CC[i2][j]*drr2[i-j];
      }
      r[i]=r[i-1]+dt*drp;
      dr[i]=dr[i-1]+dt*dr2p;
      double dy=dr[i]*Math.cos(t[i])-r[i]*Math.sin(t[i]);
      double dx=dr[i]*Math.sin(t[i])+r[i]*Math.cos(t[i]);
      if(Math.abs(dx)<=Double.MIN_VALUE){
      	gamma[i]=0.5*Math.PI;
      }
      else if(dx<0.0){
      	gamma[i]=Math.PI-Math.atan(dy/dx);
      }
      else{
      	gamma[i]=-Math.atan(dy/dx);
      }
      if(dy>0.0) gamma[i]+=Math.PI;
      if((gamma[i]>gammaMax) || (r[i]<=Double.MIN_VALUE)){
      	return i+1;
      }
    }
    return n;
  }

//--------------------------------------------------------------------//
/**
 * tH̃vX (W)
 * @param r <i>r</i> W
 * @param f <i>f</i> W
 * @param df <i>f</i> W1K
 * @param beta W
 * @return <i>f</i> W2K
 */
  protected static double laplaceD(double r,double f,double df,
      	      	      	      	   double beta){
    if(Math.abs(r)<=Double.MIN_VALUE){
      return -1.0;
    }
    else{
      double df2=1.0+df*df;
      return df2*(Math.sqrt(df2)*(beta*f-2.0)-df/r);
    }
  }

//--------------------------------------------------------------------//
/**
 * tH̃vX (ɍW)
 * @param t <i></i> W
 * @param r <i>r</i> W
 * @param dr <i>r</i> W1K
 * @param beta W
 * @return <i>r</i> W2K
 */
  protected static double laplaceP(double t,double r,double dr,
      	      	      	      	   double beta){
    if((Math.sin(t)<=Double.MIN_VALUE)
    || (Math.abs(r)<=Double.MIN_VALUE)){
      return 0.0;
    }
    else{
      double dr2=r*r+dr*dr;
      return dr2/r*(Math.sqrt(dr2)*(beta*(r*Math.cos(t)-1.0)-2.0)
      	    -(dr*Math.cos(t)/(r*Math.sin(t))-3.0))-r;
    }
  }
}
