package drop;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.MemoryImageSource;
import java.lang.*;
import java.text.DecimalFormat;
import gui.BasicViewCanvas;

//--------------------------------------------------------------------//
/**
 * ʕ\LoX
 */
public class DropViewCanvas extends BasicViewCanvas{

/** l */
  protected static final DecimalFormat
    DFORM=new DecimalFormat("#######0.000");

/** tHf[^f */
  protected DropModel model;

/** W  */
  public double beta;

/** ڐGp */
  public double gamma;

/** _]x */
  protected double vx;

/** c_]x */
  protected double vy;

/** ϊꍇ true */
  protected boolean perspect;

/** wiF */
  protected Color bgColor;

/** tHg */
  protected Font font;

/**
 * ʕ\LoX\z
 * @param font tHg
 * @param bgColor wiF
 */
  public DropViewCanvas(Font font,Color bgColor){
    super();
    this.font=font;
    this.bgColor=bgColor;
    beta=0.1;
    gamma=Math.PI/2.0;
    vx=1.0;
    vy=1.0;
    perspect=false;
    setBackground(bgColor);
  }

//--------------------------------------------------------------------//
/**
 * \]
 * @param dx ړʂ <i>x</i> 
 * @param dy ړʂ <i>y</i> 
 */
  public void rotate(int dx,int dy){
    model.viewRotate(vx*(double)dx,vy*(double)dy);
  }

//--------------------------------------------------------------------//
/**
 * p[^ݒ肷
 * @param beta W 
 * @param gamma ڐGp
 */
  public void setParameters(double beta,double gamma){
    this.beta=beta;
    this.gamma=gamma;
    model.setDrop(beta,gamma);
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * ϊsǂݒ肷
 * @param perspect ϊsꍇ true
 */
  public void setPerspect(boolean perspect){
    this.perspect=perspect;
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 * @param g `悷OtBbNXReLXg
 */
  public void update(Graphics g){
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    g.setFont(font);
    setPaint();
    model.setDrop(beta,gamma);
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * ʂ̐ݒ
 */
  protected void setPaint(){
    super.setPaint();
    vx=360.0*vx/Math.min(panelSize.width,panelSize.height);
    vy=360.0*vy/Math.min(panelSize.width,panelSize.height);
    model=new DropModel(panelSize);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintModel(Graphics2D g){
    int pixel[]=model.getPixel(DropModel.GOURAUD,perspect,bgColor);
    Image renderImage=createImage(new MemoryImageSource
      (panelSize.width,panelSize.height,pixel,0,panelSize.width));
    g.drawImage(renderImage,0,0,this);
    drawHeightVolume(g);
  }

//--------------------------------------------------------------------//
/**
 * tH̍E̐ς`悷
 * @param g `悷OtBbNXReLXg
 */
  protected void drawHeightVolume(Graphics2D g){
    FontMetrics fm=g.getFontMetrics();
    String height="height = "+DFORM.format(model.height);
    String volume="volume = "+DFORM.format(model.volume);

    int sx=Math.max(fm.stringWidth(height),fm.stringWidth(volume));
    int sy=fm.getHeight();
    g.setColor(Color.black);
    g.fillRect(0,0,sx+10,2*sy+20);
    g.setColor(Color.white);
    g.drawString(height,5,sy+5);
    g.drawString(volume,5,2*sy+15);
  }
}
