package figure;
import java.awt.Color;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * ]ʃNX
 */
public class Rotate implements PolygonCollection{

/** ]̖ʂ̕ */
  public static final int THETA=36;

/** SxNg */
  protected Vector3D axis;

/** ʂ̐ */
  protected int n;

/** |Si[z */
  protected Polygon3D pl[];

/**
 * ]ʃIuWFNg쐬
 * @param org _
 * @param axis ]xNg
 * @param n ]֐̃f[^_̐
 * @param x ֐ <i>x</i> Wi[z
 * @param y ֐ <i>y</i> Wi[z
 */
  public Rotate(Point3D org,Vector3D axis,int n,double x[],double y[]){
    this.n=(n-1)*THETA;
    pl=new Polygon3D[this.n];
    double dtheta=2.0*Math.PI/(double)THETA;

    this.axis=axis;
    double x1=x[0];
    double y1=y[0];
    double vx1=(y[1]-y[0]);
    double vy1=-(x[1]-x[0]);
    int j0=0;
    for(int i=1;i<n;i++){
      double x2=x[i];
      double y2=y[i];
      int i1=Math.min(i+1,n-1);
      double vx2=(y[i1]-y[i-1]);
      double vy2=-(x[i1]-x[i-1]);
      if(y1==0.0){
      	createUprCorn(y2,x1,x2,vx1,vy1,vx2,vy2,j0,THETA,dtheta);
      }
      else if(y2==0.0){
      	createLwrCorn(y1,x1,x2,vx1,vy1,vx2,vy2,j0,THETA,dtheta);
      }
      else{
      	createCylinder(x1,y1,x2,y2,vx1,vy1,vx2,vy2,j0,THETA,dtheta);
      }
      x1=x2;
      y1=y2;
      vx1=vx2;
      vy1=vy2;
      j0+=THETA;
    }
    for(int i=0;i<this.n;i++){
      pl[i].translate(org.x,org.y,org.z);
    }
  }

//--------------------------------------------------------------------//
/**
 * _ɂ~ʂ쐬
 * @param y ʂ̔a
 * @param x1 _̍W
 * @param x2 ʂ̍W
 * @param vx1 _̖@xNg <i>x</i> 
 * @param vy1 _̖@xNg <i>y</i> 
 * @param vx2 ʂ̖@xNg <i>x</i> 
 * @param vy2 ʂ̖@xNg <i>y</i> 
 * @param beginIndex |Si[z̊JnCfbNX
 * @param n ]̖ʂ̕
 * @param dtheta 1̖ʂ̊px
 */
  protected void createUprCorn(double y,double x1,double x2,
      	      	      	       double vx1,double vy1,double vx2,double vy2,
      	      	      	       int beginIndex,int n,double dtheta){
    Point3D p[]={new Point3D(0.0,0.0,x1),
      	      	 new Point3D(y,0.0,x2),
      	      	 new Point3D(y,0.0,x2)};
    Vector3D v[]={new Vector3D(vy1,0.0,vx1),
      	      	  new Vector3D(vy2,0.0,vx2),
      	      	  new Vector3D(vy2,0.0,vx2)};
    for(int i=0;i<n;i++){
      p[2].rotZ(dtheta);
      v[2].rotZ(dtheta);
      pl[beginIndex+i]=new Polygon3D(3,p);
      pl[beginIndex+i].setNormVector(v);
      p[1].rotZ(dtheta);
      v[1].rotZ(dtheta);
    }
  }

//--------------------------------------------------------------------//
/**
 * _ɂ~ʂ쐬
 * @param y ʂ̔a
 * @param x1 ʂ̍W
 * @param x2 _̍W
 * @param vx1 ʂ̖@xNg <i>x</i> 
 * @param vy1 ʂ̖@xNg <i>y</i> 
 * @param vx2 _̖@xNg <i>x</i> 
 * @param vy2 _̖@xNg <i>y</i> 
 * @param beginIndex |Si[z̊JnCfbNX
 * @param n ]̖ʂ̕
 * @param dtheta 1̖ʂ̊px
 */
  protected void createLwrCorn(double y,double x1,double x2,
      	      	      	       double vx1,double vy1,double vx2,double vy2,
      	      	      	       int beginIndex,int n,double dtheta){
    Point3D p[]={new Point3D(y,0.0,x1),
      	      	 new Point3D(y,0.0,x1),
      	      	 new Point3D(0.0,0.0,x2)};
    Vector3D v[]={new Vector3D(vy1,0.0,vx1),
      	      	  new Vector3D(vy1,0.0,vx1),
      	      	  new Vector3D(vy2,0.0,vx2)};
    for(int i=0;i<n;i++){
      p[0].rotZ(dtheta);
      v[0].rotZ(dtheta);
      pl[beginIndex+i]=new Polygon3D(3,p);
      pl[beginIndex+i].setNormVector(v);
      p[1].rotZ(dtheta);
      v[1].rotZ(dtheta);
    }
  }

//--------------------------------------------------------------------//
/**
 * `]ʂ쐬
 * @param x1 ʂ <i>x</i> W
 * @param y1 ʂ <i>y</i> W
 * @param x2 ʂ <i>x</i> W
 * @param y2 ʂ <i>y</i> W
 * @param vx1 ʂ̖@xNg <i>x</i> 
 * @param vy1 ʂ̖@xNg <i>y</i> 
 * @param vx2 ʂ̖@xNg <i>x</i> 
 * @param vy2 ʂ̖@xNg <i>y</i> 
 * @param beginIndex |Si[z̊JnCfbNX
 * @param n ]̖ʂ̕
 * @param dtheta 1̖ʂ̊px
 */
  protected void createCylinder(double x1,double y1,double x2,double y2,
      	      	      	      	double vx1,double vy1,double vx2,double vy2,
      	      	      	      	int beginIndex,int n,double dtheta){
    Point3D p[]={new Point3D(y1,0.0,x1),
      	      	 new Point3D(y1,0.0,x1),
      	      	 new Point3D(y2,0.0,x2),
      	      	 new Point3D(y2,0.0,x2)};
    Vector3D v[]={new Vector3D(vy1,0.0,vx1),
      	      	  new Vector3D(vy1,0.0,vx1),
      	      	  new Vector3D(vy2,0.0,vx2),
      	      	  new Vector3D(vy2,0.0,vx2)};
    for(int i=0;i<n;i++){
      p[0].rotZ(dtheta);
      p[3].rotZ(dtheta);
      v[0].rotZ(dtheta);
      v[3].rotZ(dtheta);
      pl[beginIndex+i]=new Polygon3D(4,p);
      pl[beginIndex+i].setNormVector(v);
      p[1].rotZ(dtheta);
      p[2].rotZ(dtheta);
      v[1].rotZ(dtheta);
      v[2].rotZ(dtheta);
    }
  }

//--------------------------------------------------------------------//
/**
 * \Fݒ肷
 * @param color ݒ肷\F
 */
  public void setColor(Color color){
    for(int i=0;i<n;i++){
      pl[i].setColor(color);
    }
  }

//--------------------------------------------------------------------//
/**
 * |S̐Ԃ
 * @return |S̐
 */
  public int getCount(){
    return n;
  }

//--------------------------------------------------------------------//
/**
 * |SԂ
 * @param index |SoCfbNX
 * @return w肳ꂽʒũ|S
 */
  public Polygon3D getPolygon(int index){
    return pl[index];
  }
}
