package figure;
import java.awt.geom.Point2D;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * WpxNX
 */
public class SphericalAngle implements Cloneable{

/** cos<i></i> */
  protected double ctheta;

/** sin<i></i> */
  protected double stheta;

/** cos<i></i> */
  protected double cphy;

/** sin<i></i> */
  protected double sphy;

/**
 * WpxIuWFNg̍\z
 */
  public SphericalAngle(){
    this(0.0,0.0);
  }

/**
 * WpxIuWFNg̍\z
 * @param theta <i></i>
 * @param phy <i></i>
 */
  public SphericalAngle(double theta,double phy){
    set(theta,phy);
  }

/**
 * WpxIuWFNg̍\z
 * @param theta (<i></i>,<i></i>) \ <code>Point2D</code>
 */
  public SphericalAngle(Point2D theta){
    this(theta.getX(),theta.getY());
  }

//--------------------------------------------------------------------//
/**
 * pxݒ肷
 * @param theta <i></i>
 * @param phy <i></i>
 */
  public void set(double theta,double phy){
    ctheta=Math.cos(theta);
    stheta=Math.sin(theta);
    cphy=Math.cos(phy);
    sphy=Math.sin(phy);
  }

//--------------------------------------------------------------------//
/**
 * pxݒ肷
 * @param theta (<i></i>,<i></i>) \ <code>Point2D</code>
 */
  public void set(Point2D theta){
    set(theta.getX(),theta.getY());
  }

//--------------------------------------------------------------------//
/**
 * px]
 * @param dtheta <i></i> ]p
 * @param dphy <i></i> ]p
 */
  public void rotate(double dtheta,double dphy){
    double cdtheta=Math.cos(dtheta);
    double sdtheta=Math.sin(dtheta);
    double cdphy=Math.cos(dphy);
    double sdphy=Math.sin(dphy);

    double tc=ctheta*cdtheta-stheta*sdtheta;
    double ts=stheta*cdtheta+ctheta*sdtheta;
    ctheta=tc;
    stheta=ts;
    tc=cphy*cdphy-sphy*sdphy;
    ts=sphy*cdphy+cphy*sdphy;
    cphy=tc;
    sphy=ts;
  }

//--------------------------------------------------------------------//
/**
 * __𒆐SƂĉ]
 * @param p ]_\ <code>Point3D</code>
 */
  public void rotate(Point3D p){
    double temp=p.x*ctheta+p.y*stheta;
    double x=-p.x*stheta+p.y*ctheta;
    double y=temp*sphy+p.z*cphy;
    double z=temp*cphy-p.z*sphy;
    p.setLocation(x,y,z);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long ll[]={Double.doubleToLongBits(ctheta),
      	       Double.doubleToLongBits(stheta),
      	       Double.doubleToLongBits(cphy),
      	       Double.doubleToLongBits(sphy)};
    int bit=0;
    for(int i=0;i<ll.length;i++){
      bit=31*bit+(int)(ll[i]^(ll[i]>>>32));
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>SphericalAngle</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof SphericalAngle){
      SphericalAngle sa=(SphericalAngle)obj;
      return ((ctheta==sa.ctheta)
      	   && (stheta==sa.stheta)
      	   && (cphy==sa.cphy)
      	   && (sphy==sa.sphy));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "SA\t"+ctheta+"\t"+stheta+"\t"+cphy+"\t"+sphy;
  }
}
