package figure;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * 3̐l̏WNX
 */
public class Tuple3D implements Cloneable{

/** <i>x</i> W */
  public double x;

/** <i>y</i> W */
  public double y;

/** <i>z</i> W */
  public double z;

/**
 * ftHgl (0,0,0) ŏW\z
 */
  public Tuple3D(){
    this(0.0,0.0,0.0);
  }

/**
 * Wlw肵ďW\z
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @param z <i>z</i> W
 */
  public Tuple3D(double x,double y,double z){
    this.x=x;
    this.y=y;
    this.z=z;
  }

/**
 * W t ƓW\z
 * @param t QƂ <code>Tuple3D</code>
 */
  public Tuple3D(Tuple3D t){
    this(t.x,t.y,t.z);
  }

//--------------------------------------------------------------------//
/**
 * <i>x</i> Wݒ肷
 * @param x <i>x</i> W
 */
  public void setX(double x){
    this.x=x;
  }

//--------------------------------------------------------------------//
/**
 * <i>y</i> Wݒ肷
 * @param y <i>y</i> W
 */
  public void setY(double y){
    this.y=y;
  }

//--------------------------------------------------------------------//
/**
 * <i>z</i> Wݒ肷
 * @param z <i>z</i> W
 */
  public void setZ(double z){
    this.z=z;
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @param z <i>z</i> W
 */
  public void set(double x,double y,double z){
    this.x=x;
    this.y=y;
    this.z=z;
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param t QƂ <code>Tuple3D</code>
 */
  public void set(Tuple3D t){
    set(t.x,t.y,t.z);
  }

//--------------------------------------------------------------------//
/**
 * Wl
 * @param dx <i>x</i> W
 * @param dy <i>y</i> W
 * @param dz <i>z</i> W
 */
  public void add(double dx,double dy,double dz){
    x+=dx;
    y+=dy;
    z+=dz;
  }

//--------------------------------------------------------------------//
/**
 * Wl
 * @param dt  <code>Tuple3D</code>
 */
  public void add(Tuple3D dt){
    add(dt.x,dt.y,dt.z);
  }

//--------------------------------------------------------------------//
/**
 * <i>x</i> ]
 * @param theta ]px (rad)
 */
  public void rotX(double theta){
    rotX(Math.cos(theta),Math.sin(theta));
  }

//--------------------------------------------------------------------//
/**
 * <i>x</i> ]
 * @param cc ]px <code>cos</code>
 * @param ss ]px <code>sin</code>
 */
  public void rotX(double cc,double ss){
    double ty=cc*y-ss*z;
    double tz=ss*y+cc*z;
    y=ty;
    z=tz;
  }

//--------------------------------------------------------------------//
/**
 * <i>y</i> ]
 * @param theta ]px
 */
  public void rotY(double theta){
    rotY(Math.cos(theta),Math.sin(theta));
  }

//--------------------------------------------------------------------//
/**
 * <i>y</i> ]
 * @param cc ]px <code>cos</code>
 * @param ss ]px <code>sin</code>
 */
  public void rotY(double cc,double ss){
    double tz=cc*z-ss*x;
    double tx=ss*z+cc*x;
    x=tx;
    z=tz;
  }

//--------------------------------------------------------------------//
/**
 * <i>z</i> ]
 * @param theta ]px
 */
  public void rotZ(double theta){
    rotZ(Math.cos(theta),Math.sin(theta));
  }

//--------------------------------------------------------------------//
/**
 * <i>z</i> ]
 * @param cc ]px <code>cos</code>
 * @param ss ]px <code>sin</code>
 */
  public void rotZ(double cc,double ss){
    double tx=cc*x-ss*y;
    double ty=ss*x+cc*y;
    x=tx;
    y=ty;
  }

//--------------------------------------------------------------------//
/**
 * Cӂ̎̉]
 * @param r ]\ <code>Tuple3D</code>
 * @param theta ]px
 */
  public void rot(Tuple3D r,double theta){
    rot(r.x,r.y,r.z,Math.cos(theta),Math.sin(theta));
  }

//--------------------------------------------------------------------//
/**
 * Cӂ̎̉]
 * @param rx ] <code>x</code> 
 * @param ry ] <code>y</code> 
 * @param rz ] <code>z</code> 
 * @param theta ]px
 */
  public void rot(double rx,double ry,double rz,double theta){
    rot(rx,ry,rz,Math.cos(theta),Math.sin(theta));
  }

//--------------------------------------------------------------------//
/**
 * Cӂ̎̉]
 * @param rx ] <code>x</code> 
 * @param ry ] <code>y</code> 
 * @param rz ] <code>z</code> 
 * @param cc ]px <code>cos</code>
 * @param ss ]px <code>sin</code>
 */
  public void rot(double rx,double ry,double rz,double cc,double ss){
    double rr=Math.sqrt(rx*rx+ry*ry+rz*rz);
    if(rr<=Double.MIN_VALUE) return;
    rx/=rr;
    ry/=rr;
    rz/=rr;
    double rcx=rx*(1.0-cc);
    double rcy=ry*(1.0-cc);
    double rcz=rz*(1.0-cc);
    double tx=(cc+rx*rcx)*x+(-rz*ss+ry*rcx)*y+(ry*ss+rz*rcx)*z;
    double ty=(rz*ss+rx*rcy)*x+(cc+ry*rcy)*y+(-rx*ss+rz*rcy)*z;
    double tz=(-ry*ss+rx*rcz)*x+(rx*ss+ry*rcz)*y+(cc+rz*rcz)*z;
    x=tx;
    y=ty;
    z=tz;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long lx=Double.doubleToLongBits(x);
    long ly=Double.doubleToLongBits(y);
    long lz=Double.doubleToLongBits(z);
    int bit=(int)(lx^(lx>>>32));
    bit=31*bit+(int)(ly^(ly>>>32));
    bit=31*bit+(int)(lz^(lz>>>32));
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>Tuple3D</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Tuple3D){
      Tuple3D t=(Tuple3D)obj;
      return ((x==t.x) && (y==t.y) && (z==t.z));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Tuple3D\t"+x+"\t"+y+"\t"+z;
  }
}
