package shading;
import java.awt.Color;
import java.awt.Dimension;
import java.lang.*;
import figure.Point3D;
import figure.Polygon3D;
import figure.Vector3D;
import math.InterPolation;

//--------------------------------------------------------------------//
/**
 * O[[VF[fBONX
 */
public class GouraudShading extends Shading{

/**
 * O[[VF[fBOIuWFNg\z
 * @param width ʕ
 * @param height ʍ
 * @param viewPoint _
 * @param lightPoint 
 * @param perspect ϊꍇ true
 */
  public GouraudShading(int width,int height,Point3D viewPoint,
      	      	      	Point3D lightPoint,boolean perspect){
    super(width,height,viewPoint,lightPoint,perspect);
  }

/**
 * O[[VF[fBOIuWFNg\z
 * @param size ʃTCY
 * @param viewPoint _
 * @param lightPoint 
 * @param perspect ϊꍇ true
 */
  public GouraudShading(Dimension size,Point3D viewPoint,
      	      	      	Point3D lightPoint,boolean perspect){
    this(size.width,size.height,viewPoint,lightPoint,perspect);
  }

//--------------------------------------------------------------------//
/**
 * |S̃VF[fBO`vZ
 * @param pl |S
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public void shading(Polygon3D pl,int pixel[],double zbuf[]){
    int n=pl.n;
    int ymax=0;
    int ymin=height-1;
    int s0=0;
    int s1=0;
    Point3D ps[]=new Point3D[n];
    Color col[]=new Color[n];
    for(int i=0;i<n;i++){
      ps[i]=screen(pl.p[i]);
      Vector3D viewV=new Vector3D(viewPoint,pl.p[i]);
      viewV.normalize();
      Vector3D lightv=new Vector3D(lightPoint,pl.p[i]);
      lightv.normalize();
      col[i]=LIGHT_MODEL.getColor(viewV,lightv,pl.nvp[i],pl.color,1.5,
      	      	      	      	  false);
      ymax=Math.max(ymax,(int)ps[i].y);
      if((int)ps[i].y<ymin){
      	ymin=(int)ps[i].y;
      	s0=i;
      	s1=i;
      }
      else if((int)ps[i].y==ymin){
      	s0=i;
      }
    }
    ymin=Math.max(ymin,0);
    ymax=Math.min(ymax,height-1);
    for(int y=ymin;y<=ymax;y++){
      if((int)ps[(s0+1)%n].y<y) s0=(s0+1)%n;
      if((int)ps[(s1-1+n)%n].y<y) s1=(s1-1+n)%n;
      int s2=(s0+1)%n;
      int s3=(s1-1+n)%n;
      Point3D p1=InterPolation.linear(ps[s0],ps[s2],y-(int)ps[s0].y,
      	      	      	      	      (int)ps[s2].y-y);
      Point3D p2=InterPolation.linear(ps[s1],ps[s3],y-(int)ps[s1].y,
      	      	      	      	      (int)ps[s3].y-y);
      Color c1=InterPolation.linear(col[s0],col[s2],y-(int)ps[s0].y,
      	      	      	      	    (int)ps[s2].y-y);
      Color c2=InterPolation.linear(col[s1],col[s3],y-(int)ps[s1].y,
      	      	      	      	    (int)ps[s3].y-y);
      int xmin=Math.max((int)Math.min(p1.x,p2.x),0);
      int xmax=Math.min((int)Math.max(p1.x,p2.x),width-1);
      for(int x=xmin;x<=xmax;x++){
      	Point3D p3=InterPolation.linear(p1,p2,x-(int)p1.x,(int)p2.x-x);
      	Color c3=InterPolation.linear(c1,c2,x-(int)p1.x,(int)p2.x-x);
      	int ii=width*y+x;
      	if(zbuf[ii]<p3.z){
      	  pixel[ii]=c3.getRGB();
      	  zbuf[ii]=p3.z;
      	}
      }
    }
  }
}
