package shading;
import java.awt.Color;
import java.lang.*;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * o[fNX
 */
public class LambertModel implements LightModel{

/** gUˌW */
  protected double kd;

/** W */
  protected double ke;

/**
 * o[fIuWFNg\z
 * @param kd gUˌW
 * @param ke W
 */
  public LambertModel(double kd,double ke){
    this.kd=kd;
    this.ke=ke;
  }

//--------------------------------------------------------------------//
/**
 * ˌvZ
 * @param viewVector xNg
 * @param lightVector xNg
 * @param normVector ʂ̖@xNg
 * @param color Ώە̐F
 * @param s ̋
 * @param shadow e̕ true
 * @return \F
 */
  public Color getColor(Vector3D viewVector,Vector3D lightVector,
      	      	      	Vector3D normVector,Color color,double s,
      	      	      	boolean shadow){
    double cd=ke;
    if(!shadow){
      double rc=-Vector3D.innerProduct(lightVector,normVector);
      cd+=s*kd*Math.max(rc,0.0);
    }
    int rr=Math.min((int)(cd*(double)color.getRed()),255);
    int gg=Math.min((int)(cd*(double)color.getGreen()),255);
    int bb=Math.min((int)(cd*(double)color.getBlue()),255);
    return new Color(rr,gg,bb);
  }
}
