package shading;
import java.awt.Color;
import java.lang.*;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * tHfNX
 */
public class PhongModel implements LightModel{

/** gUˌW */
  protected double kd;

/** ʔˌW */
  protected double ks;

/** ʔ˂̋xW */
  protected int ns;

/** W */
  protected double ke;

/**
 * tHfIuWFNg\z
 * @param kd gUˌW
 * @param ks ʔˌW
 * @param ns ʔ˂̋xW
 * @param ke W
 */
  public PhongModel(double kd,double ks,int ns,double ke){
    this.kd=kd;
    this.ks=ks;
    this.ns=ns;
    this.ke=ke;
  }

//--------------------------------------------------------------------//
/**
 * ˌvZ
 * @param viewVector xNg
 * @param lightVector xNg
 * @param normVector ʂ̖@xNg
 * @param color Ώە̐F
 * @param s ̋
 * @param shadow e̕ true
 * @return \F
 */
  public Color getColor(Vector3D viewVector,Vector3D lightVector,
      	      	      	Vector3D normVector,Color color,double s,
      	      	      	boolean shadow){
    double cd=ke;
    double cs=0.0;
    if(!shadow){
      double rc=-Vector3D.innerProduct(lightVector,normVector);
      cd+=s*kd*Math.max(rc,0.0);
      Vector3D reflect=new Vector3D(lightVector.x+2.0*rc*normVector.x,
      	      	      	      	    lightVector.y+2.0*rc*normVector.y,
      	      	      	      	    lightVector.z+2.0*rc*normVector.z);
      rc=-Vector3D.innerProduct(reflect,viewVector);
      cs=s*ks*Math.pow(Math.max(rc,0.0),ns);
    }
    int rr=Math.min((int)(cd*(double)color.getRed()+cs*255.0),255);
    int gg=Math.min((int)(cd*(double)color.getGreen()+cs*255.0),255);
    int bb=Math.min((int)(cd*(double)color.getBlue()+cs*255.0),255);
    return new Color(rr,gg,bb);
  }
}
