package shading;
import java.awt.Color;
import java.lang.*;
import figure.Point3D;
import figure.Polygon3D;
import figure.PolygonCollection;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * VF[fBO̒ۃX[p[NX
 */
public abstract class Shading{

/** wIf */
  protected static final LightModel
    LIGHT_MODEL=new PhongModel(0.7,0.7,20,0.4);

/** ʕ */
  protected int width;

/** ʍ */
  protected int height;

/** _ */
  protected Point3D viewPoint;

/**  */
  protected Point3D lightPoint;

/** ϊꍇ true */
  protected boolean perspect;

/**
 * VF[fBOIuWFNg\z
 * @param width ʕ
 * @param height ʍ
 * @param viewPoint _
 * @param lightPoint 
 * @param perspect ϊꍇ true
 */
  protected Shading(int width,int height,Point3D viewPoint,
      	      	    Point3D lightPoint,boolean perspect){
    this.width=width;
    this.height=height;
    this.viewPoint=viewPoint;
    this.lightPoint=lightPoint;
    this.perspect=perspect;
  }

//--------------------------------------------------------------------//
/**
 * |S̃VF[fBO`vZ
 * @param pl |S
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public abstract void shading(Polygon3D pl,int pixel[],double zbuf[]);

//--------------------------------------------------------------------//
/**
 * |SW̃VF[fBO`vZ
 * @param pc |SW
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public void shading(PolygonCollection pc,int pixel[],double zbuf[]){
    int n=pc.getCount();
    for(int i=0;i<n;i++){
      shading(pc.getPolygon(i),pixel,zbuf);
    }
  }

//--------------------------------------------------------------------//
/**
 * [hWʍWɕϊ
 * @param p ϊO̓_
 * @return ϊ̓_
 */
  protected Point3D screen(Point3D p){
    Vector3D viewVector=new Vector3D(viewPoint);
    double d1=viewVector.magnitude();
    viewVector.normalize();
    Point3D p2=(Point3D)p.clone();
    double d2=viewVector.x*viewVector.x+viewVector.y*viewVector.y;
    if(d2>Double.MIN_VALUE){
      d2=Math.sqrt(d2);
      p2.rotZ(-viewVector.y/d2,-viewVector.x/d2);
      p2.rotX(viewVector.z,-d2);
    }
    if(perspect){
      d1=1.0-p2.z/d1;
      return new Point3D(0.5*(double)width+p2.x/d1,
      	      	      	 0.5*(double)height-p2.y/d1,p2.z);
    }
    else{
      return new Point3D(0.5*(double)width+p2.x,
      	      	      	 0.5*(double)height-p2.y,p2.z);
    }
  }
}
